﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Infragistics.Windows.Reporting;

namespace XamGridWPFReporting
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            double pageSize = 19;
            double pageNum = 1;
            double totalPages = xamGrid.Rows.Count / pageSize;

            xamGrid.ScrollCellIntoView(xamGrid.Rows[0].Cells[0]);

            while (true)
            {
                Report objReport = new Report();
                ReportProgressControl progress = new ReportProgressControl();
                objReport.ReportSettings.Margin = new Thickness(5, 5, 5, 5);
                objReport.ReportSettings.HorizontalPaginationMode = HorizontalPaginationMode.Scale;
                objReport.ReportSettings.PageOrientation = PageOrientation.Portrait;

                objReport.Sections.Add(new EmbeddedVisualReportSection(xamGrid));

                objReport.ReportSettings.RepeatType = RepeatType.PageBreak;
                objReport.PageHeader = "Header";
                progress.Report = objReport;

                objReport.Print(true, true);

                pageNum += 1.0;
                double scrollToIndex = Math.Min(pageSize * pageNum - 1.0, xamGrid.Rows.Count - 1.0);
                xamGrid.ScrollCellIntoView(xamGrid.Rows[(int)scrollToIndex].Cells[0]);

                if (pageNum > totalPages + 1)
                    break;
            }
        }
    }
}
